module GStar

import DataStructures: PriorityQueue, enqueue!, dequeue_pair!
import Parameters: @with_kw

using Nullables
#=
When a node is expanded, each of its successors has 3 possible destinations
A1. discarded. The edge is not feasible. This is indicated by the `push_successors!` producing edge_cost = Inf
A2. placed on the open list if the edge is feasible and valid
A3 placed on the preopen list if the edge is feasible but not valid

1 and 2 are normal. 3 is the Global* part.

An edge is feasible if it is collision free.
An edge is valid if it is observed by the stuff in alg.closed

The open list receives nodes from two possible sources:
B1. expansions of recently closed nodes (same as A2)
B2. recently valid edges from the preopen list.


`step!` does a typical A* steps (A1, A2/B1) and also A3
`step_preopen!` does step B2.

=#

# What is needed to compute the f-value
# reprsents a state and the cost to get to that state.
struct GStarNode{STATE, COST}
  state::STATE
  g_value::COST # cost from start
end

# These are the values in a dict keyed by state. They give for that state the parent state and the g_value.
struct GStarClosedNode{STATE, COST}
  state_from::STATE
  g_value::COST # cost from start to the key
end

#= What is needed to compute the back-pointers.
The other option is to have a separate CLOSED list and PARENTS map,
and populate PARENTS only if a shorter path is found. I like combining these ideas.
Then the queue is the only thing responsible for comparing costs.
But as a result, the OPEN list must keep track of which parent was used to get to a node.=#
struct GStarOpenNode{STATE, COST}
  node::GStarNode{STATE, COST}
  parent::STATE
end

# What is generated by the `push_successors!` function
struct GStarSuccessor{STATE, COST}
  state_to::STATE
  edge_cost::COST
end

# What is used to re-try edges that were originally invalid
struct GStarPreOpenNode{STATE, COST}
  node_from::GStarNode{STATE, COST}
  successor::GStarSuccessor{STATE, COST}
end

@with_kw struct GStarInstance{FH,FG,FE,FV}
  transition_valid::FV = (s2, s1, a) -> true  # (state_to::STATE, state_from::STATE, alg::GStarAlgorithm) ↦ ::Bool
  # NOTE transition may depend on search state. Should only depend on alg.closed for step_preopen! iteration order not to matter
  heuristic::FH = (node) -> node.g_value      # state::GStarNode{STATE, COST} ↦ f_value::COST
  # NOTE `heuristic` returns the f = g+ h value, not h value. This lets the user do BFS, A*, greedy best-first search, ...
  goal_test::FG = (s) -> false                 # state::STATE ↦ ::Bool
  push_successors!::FE                        # (Set{GStarSuccessor{STATE, COST}}, state_from::State) ↦ ::Nothing
  # the first argument to `push_successors!` just needs to support push!, empty! and iteration
end

@with_kw struct GStarAlgorithm{STATE, COST, INSTANCE}
  instance::INSTANCE
  # closed contains nodes whose path from the start has been permanently decided.
  closed::Dict{STATE, GStarClosedNode{STATE, COST}} = Dict{STATE, GStarClosedNode{STATE, COST}}()

  # open contains nodes that are feasible to reach
  open::PriorityQueue{GStarOpenNode{STATE, COST}, COST} = PriorityQueue{GStarOpenNode{STATE, COST}, COST}()

  # preopen contains edges that were not valid to reach, but may become valid.
  preopen::Set{GStarPreOpenNode{STATE, COST}} = Set{GStarPreOpenNode{STATE, COST}}()

  # keep track of what finally let a node move from preopen to open
  # if procedure step_preopn! runs, for each step!, then there will only be one node
  # otherwise, it will be a list of possible nodes.
  # note that other nodes may also have been required to license the edge.
  preclosed::Dict{STATE, Vector{STATE}} = Dict{STATE, Vector{STATE}}()

  children::Vector{GStarSuccessor{STATE, COST}} = GStarSuccessor{STATE, COST}[] # workspace for `push_successors!`
  goal_state::Ref{Nullable{STATE}} = Ref{Nullable{STATE}}()

  closed_since_step_preopen::Vector{STATE} = STATE[]
end

function Base.empty!(alg::GStarAlgorithm)
  empty!(alg.closed)
  while !isempty(alg.open); dequeue!(alg.open); end # at time of writing, there is no empty! method
  empty!(alg.preopen)
  empty!(alg.preclosed)
  empty!(alg.children)
  alg.goal_state[] = nothing
  return nothing
end

function setup!(alg::GStarAlgorithm{STATE, COST, INSTANCE}, start_state, start_cost=zero(COST)) where {STATE, COST, INSTANCE}
  empty!(alg)
  start_node = GStarNode(start_state, start_cost)
  start_queue_node = GStarOpenNode(start_node, start_state)
  enqueue!(alg.open, start_queue_node=>alg.instance.heuristic(start_node)) # technically should add h too
  return nothing
end

isclosed(alg::GStarAlgorithm, state) = haskey(alg.closed, state)

function step_preopen!(alg::GStarAlgorithm)
  remove = []
  for preopen_node in alg.preopen
    if alg.instance.transition_valid(preopen_node.successor.state_to, preopen_node.node_from.state, alg)
      # now it's valid
      add_to_open!(alg, preopen_node.successor, preopen_node.node_from)
      push!(remove, preopen_node)
      alg.preclosed[preopen_node.successor.state_to] = copy(alg.closed_since_step_preopen)
    end
  end

  for preopen_node in remove
    delete!(alg.preopen, preopen_node)
  end
  empty!(alg.closed_since_step_preopen)
  return nothing
end

function add_to_open!(alg::GStarAlgorithm, child::GStarSuccessor, expandme::GStarNode)
  child_g_value = expandme.g_value + child.edge_cost
  child_node = GStarNode(child.state_to, child_g_value)
  child_f_value = alg.instance.heuristic(child_node)
  child_queue_node = GStarOpenNode(child_node, expandme.state)
  enqueue!(alg.open, child_queue_node => child_f_value)
  return nothing
end

function step!(alg::GStarAlgorithm{STATE, COST, GI}) where {STATE, COST, GI}
  if isempty(alg.open)
     return (keepgoing=false, reason=:empty_agenda)
  end

  expandme_queue, expandme_f_value = dequeue_pair!(alg.open)
  expandme = expandme_queue.node

  if isclosed(alg, expandme.state)
    # already decided on an edge to this state.
    return (keepgoing=true, reason=:closed)
  end

  # add state to closed list and mark its parent and its g-value
  alg.closed[expandme_queue.node.state] = GStarClosedNode(expandme_queue.parent, expandme_queue.node.g_value)

  if alg.instance.goal_test(expandme.state)
    alg.goal_state[] = expandme.state
    return (keepgoing=false, reason=:goal)
  end

  push!(alg.closed_since_step_preopen, expandme_queue.node.state)
  #step_preopen!(alg)

  empty!(alg.children)
  alg.instance.push_successors!(alg.children, expandme.state)

  for child in alg.children
    if isclosed(alg, child.state_to)
      # path to `child.state` has already been determined
      continue
    end

    if child.edge_cost == typemax(typeof(child.edge_cost))
      # edge is not valid, and never will be.
      continue
    end

    if !alg.instance.transition_valid(child.state_to, expandme.state, alg)
      # edge is not valid now. but we have to consider it later.
      push!(alg.preopen, GStarPreOpenNode(expandme, child))
      continue
    end

    add_to_open!(alg, child, expandme)
  end

  return (keepgoing=true, reason=:none)
end

function get_path(alg::GStarAlgorithm{S, C, I}, end_::S) where {S, C, I}
  reached = Set{S}()
  r = S[]
  next_ = end_
  while next_ ∉ reached
    push!(reached, next_)
    push!(r, next_)
    next_ = alg.closed[next_].state_from
  end
  return r
end

end
